//Crt0_prx
//Includes
/*PSPBRICKER SOURCE FROM SANiK*/
#define _PSP_FW_VERSION 150
#include <pspkernel.h>
#include <pspkerneltypes.h>
#include <pspmoduleinfo.h>
#include <pspiofilemgr.h>
#include <pspmodulemgr.h>
#include <pspthreadman.h>
#include <pspwlan.h>
#include <stdlib.h>
#include <pspchnnlsv.h>
#include <pspctrl.h>
#include <string.h>
#include <pspctrl_kernel.h>
#include <pspdisplay.h>
#include <pspdisplay_kernel.h>
#include <pspthreadman_kernel.h>
#include <pspumd.h>
#include "crt0_prx.h"
#include "defines.h"
#include "address.h"

//Globals
SceUID thid;
unsigned char gameId[10];
unsigned int running0=0;
unsigned char imposterBuffer[0x2000];
unsigned int imposterSize=0;
unsigned int imposterOffsetBase=0;
unsigned int imposterOffsetCurrent=0;
unsigned int imposterOffsetBaseBackup=0;
unsigned int jumpBool = 0;
unsigned int imposterGroupCurrent=0;
dword cache0 = 0;
dword cache1 = 0;
unsigned int *imposterClantag=(unsigned int*)(0x804F00+0x08800000);
unsigned int *imposterDisable=(unsigned int*)(0x804F04+0x08800000);
unsigned int *imposterReload=(unsigned int*)(0x804F0C+0x08800000);
unsigned int *imposterHz=(unsigned int*)(0x804F08+0x08800000);
unsigned int *imposterGroupForced=(unsigned int*)(0x804F10+0x08800000);
unsigned int *socomLobbyData=(unsigned int*)(0x560C98+0x08800000); /*0x56AA58*/


//Functions
unsigned int upperCase(unsigned int a_letter){
  if((a_letter >= 'a') && (a_letter <= 'z')) return (a_letter + 0x20);
  return a_letter;
}

unsigned int strCompare(unsigned char* a_left, unsigned char* a_right, unsigned int a_len, unsigned int a_strpoint){
  unsigned int counter=a_strpoint;
  a_right += a_strpoint;
  a_left += a_strpoint;
  while(counter < a_len)
  {
    if(upperCase(*a_left) != upperCase(*a_right))
    {
      return 0;
    }

    a_left++;
    a_right++;
    counter++;
  }
  return 1;
}

unsigned int validatePointer(unsigned int a_address){
  if((*((unsigned int*)(a_address)) > 0x08800000) && (*((unsigned int*)(a_address)) < 0x0A000000))
  {
    return -1;
  }
  return 0;
}

void stripBootTags(unsigned char *imposterBuffer2){

  unsigned int counter=0;
  unsigned int result;

  while(counter < 40)
  {
    if((imposterBuffer2[counter] ==  '{' ) || (imposterBuffer2[counter] == '$') || (imposterBuffer2[counter] == '}'))
    {
        imposterBuffer2[counter]= 0x00;
    }
	counter++;
  }
  return;
}

void imposterFindStamp(){
  while(imposterBuffer[imposterOffsetCurrent] != 0xFE)
  {
    imposterOffsetCurrent++;

    if(imposterOffsetCurrent >= imposterSize)
    {
      imposterOffsetCurrent=0;
    }
  }
  imposterOffsetBase=imposterOffsetCurrent;
}

void imposterFindNext(){
  while(imposterBuffer[imposterOffsetCurrent] != '\n')
  {
    if(imposterBuffer[imposterOffsetCurrent] == 0xFE)
    {
      imposterOffsetCurrent=imposterOffsetBase+1;
      return;
    }

    imposterOffsetCurrent++;

    if(imposterOffsetCurrent >= imposterSize)
    {
      imposterOffsetCurrent=imposterOffsetBase+1;
      return;
    }
  }
  if(imposterBuffer[imposterOffsetCurrent+1]==0xFE)
  {
    imposterOffsetCurrent=imposterOffsetBase+1;
    return;
  }
  imposterOffsetCurrent++;
}

void watchAddress(dword address)
{
	string buffer[20];
	if(address)
	{
		if((*imposterHz != 0) && (*imposterHz <= 0x000F4240)) sceKernelDelayThread(*imposterHz);
    	else sceKernelDelayThread(1000000);
		if(!cache0) cache0 = grabAddress(address);
		if(cache0 != grabAddress(address))
		{
			sprintf(buffer, "0x%08lX has changed to ", address); fillLog(buffer); bzero(buffer, strlen(buffer));
			sprintf(buffer, "0x%08lX ", grabAddress(address)); fillLog(buffer); bzero(buffer, strlen(buffer));
			sprintf(buffer, "from 0x%08lX", cache0); baconLog(buffer); bzero(buffer, strlen(buffer));
		}
		cache0 = grabAddress(address);
	}
	return;
}

unsigned int imposterLoad(){
  imposterOffsetBase=0;
  imposterOffsetCurrent=0;
  imposterOffsetBaseBackup=0;
  imposterGroupCurrent=0;

  signed int fd=sceIoOpen("ms0:/seplugins/pspBricker.txt", PSP_O_RDONLY, 0777);
  if(fd > 0)
  {
    //Get the size of the file we opened
    imposterSize=sceIoLseek(fd, 0, 2); sceIoLseek(fd, 0, 0);

    //Is the file size > than the memory size? If so, trim the amount that will be loaded
    if(imposterSize > 0x2000) imposterSize=0x2000;

    //Load the file to memory
    sceIoRead(fd, &imposterBuffer[0], imposterSize);

    //Find the start of the current imposter
    imposterFindStamp();
    imposterOffsetCurrent++;

    //Strip the boot tags
    stripBootTags(imposterBuffer);

    //Return success
    return -1;
  }
  else
  {
    //Return error
    running0=0;
    return 0;
  }
}

int mainThread()
{

  signed int fd;
  unsigned int counter=0;
  running0=1;

  //Wait for the kernel to boot up (if we don't, the PRX will crash since some functions may be missing)
  sceKernelDelayThread(15000000);
  while(!sceKernelFindModuleByName("sceKernelLibrary"))
  sceKernelDelayThread(100000);
  sceKernelDelayThread(100000);

  //Find the GAME ID (by reading the UMD_DATA file on the UMD)
  do{
  	fd=sceIoOpen("disc0:/UMD_DATA.BIN", PSP_O_RDONLY, 0777);
    sceKernelDelayThread(10000);
  } while(fd<=0);
  sceIoRead(fd, gameId, 10);
  sceIoClose(fd);

  //Compare the gameID to see if the game is SOCOM FTB2
  if(strncmp(gameId, "UCUS-98645", 10)){
    //Nope, the game ain't SOCOM FTB2, boohoo - life sucks
    //Too bad you can't use your ultra-cool animated imposter on Coded Arms or some shit
    //*sigh*
    //Damn this Dr. Pepper's good
    running0=0;
    return 0;
  }

  //Load the imposters from the file
  if(!imposterLoad()) return 0;

  //Wait for the RAM to clear
  //Basicly we talk to nitePR using special addresses
  //Meaning, we have to wait for FTB2 to stop using these addresses so that we can claim them for our own use
  //FTB2 just uses the addresses on boot up - and nowhere else (as far as I know)
  //Which is why we're waiting for FTB2 to set the addresses to 0 before continuing (this tells us FTB2 is done with the addresses)
  while(*imposterDisable != 0x00000000){
    sceKernelDelayThread(500000);
  }
  while(*imposterHz != 0x00000000){
    sceKernelDelayThread(500000);
  }
  while(*imposterReload != 0x00000000){
    sceKernelDelayThread(500000);
  }
  //Do the loop-de-loop
  while(running0){
	start:
	watchAddress(grabAddress(0x09004f1c));
    //Wait a certain amount of seconds
    //This is what reads the BRK_SPEED
    //We first check that the speed makes sense... I mean if it's something insane like 10000000 FPS, then goto "ELSE" and shit homie
    if((*imposterHz != 0) && (*imposterHz <= 0x000F4240))
    {
      //sceKernelDelayThread(*imposterHz);
    }
    else
    {
      sceKernelDelayThread(500000);
    }

	if(*imposterHz > 0x0003D090){
		*imposterHz=0x0003D090;
	}
    //Is it disabled?
    //If the animation is disabled, just keep on looping/waiting
    if(*imposterDisable)
    {
      sceKernelDelayThread(500000);
      continue;
    }

    //Do we reload the file?
    //Reloads the file if the BRK_RELOAD file flag is set
    if(*imposterReload)
    {
      *imposterReload=0;
      if(!imposterLoad()) return 0;

      sceKernelDelayThread(500000);
      *imposterReload=0;
    }

    //Calculate the address
    //SUPER SECRET SHIT GOES HERE
    int playerId=0x08800000+0x501BCC/* 1.40 0x4FFE8C , 1,30 0x50A58C*/;
    if(!validatePointer(playerId))
    {
      continue;
    }
    playerId=*((unsigned int*)(playerId));

    //Do we need to apply any readjustment?
    if(*((unsigned int*)((unsigned int)playerId+20)) == 0x656D6147)
    {
      playerId+=0x318;
    }
    playerId=*((unsigned int*)(playerId));

    //Fetch the list of user names in the lobby
    unsigned int counter=0;
    unsigned int addressTest=0;
    while(counter < 16)
    {
      if(socomLobbyData[2*counter] == playerId)
      {
        addressTest=socomLobbyData[2*counter+1];
        break;
      }
      counter++;
    }

    //Is the address within bounds?
    if(!validatePointer((unsigned int)&socomLobbyData[2*counter+1]))
    {
      continue;
    }
    addressTest+=14;

    if(*imposterClantag)
    {
      addressTest+=32;
    }

    unsigned char *address=(unsigned char*)(addressTest);

    //Draw current frame
    int copySize=0;
    if(*imposterClantag)
    {
      address[15]=0;
    }
    else
    {
      address[31]=0;
    }
    while((copySize < ((*imposterClantag)? 15:31)) && (imposterBuffer[imposterOffsetCurrent+copySize] != '\r') && (imposterBuffer[imposterOffsetCurrent+copySize] != '\n') && ((imposterOffsetCurrent + copySize) < imposterSize))
    {
      address[copySize]=imposterBuffer[imposterOffsetCurrent+copySize];
      copySize++;
    }
    address[copySize]=0;

    //Flash the cache with the new data
    sceKernelDcacheWritebackInvalidateRange(address, copySize+1);
    sceKernelIcacheInvalidateRange(address, copySize+1);

    //Goto next
    imposterFindNext();

    //Do we need to switch to a different imposter group?
    while(*imposterGroupForced != imposterGroupCurrent)
    {
      //Backup the current offset in the buffer
      imposterOffsetBaseBackup=imposterOffsetBase;

      //Find the next animation group
      imposterFindStamp();
      imposterFindNext();

      //Now, try to relate the imposterGroup number...
      if(imposterOffsetBaseBackup < imposterOffsetBase)
      {
        //The buffer has not rolled back to the beginning, keep counting up
        imposterGroupCurrent++;
      }
      else
      {
        //The max has been reached, is *imposterGroupForced within limits?
        if(*imposterGroupForced > (imposterGroupCurrent))
        {
          *imposterGroupForced=0;
        }

        //Set the group count to zero
        imposterGroupCurrent=0;
      }
    }
	//sceKernelDelayThread(50000);
  }
  return 0;
}
